<template>
  <div ref="root" class="i-input" :class="{ 'i-input--hidden': hidden, 'i-input--loading': loading }">
    <datetime
      v-if="['date', 'time', 'datetime'].includes(type)"
      v-model="data"
      input-class="i-input__input"
      :placeholder="placeholder"
      :flow="flow"
      auto
      :format="format"
      :use12-hour="true"
      :type="type"
      value-zone="local"
      @focus="onFocus"
      @input="onInput"
      @close="onClose" />
    <input
      v-else
      ref="input"
      v-model="data"
      :type="type"
      :placeholder="placeholder"
      class="i-input__input"
      @input="onInput" />
    <img src="~assets/images/spinner-black.svg" class="i-input__spinner" />
  </div>
</template>

<script>
  import { Datetime } from 'vue-datetime';
  import { Settings, DateTime } from 'luxon';

  export default {
    components: {
      Datetime,
    },

    props: {
      placeholder: {
        type: String,
        default: '',
      },

      value: String,
      defaultValue: String,

      type: {
        type: String,
        default: 'text',
      },

      flow: Array,
      hidden: Boolean,
      loading: Boolean,
    },

    data() {
      return {
        data: this.value,
        vdatetimeDiv: null,
      };
    },

    watch: {
      value() {
        if (this.data != this.value) {
          this.data = this.value;
        }
      },
    },

    computed: {
      format() {
        if (this.type === 'date') {
          return DateTime.DATE_MED;
        }

        if (this.type === 'time') {
          return DateTime.TIME_SIMPLE;
        }

        return DateTime.DATETIME_MED;
      },
    },

    created() {
      Settings.defaultLocale = this.$i18n.locale;
    },

    mounted() {
      if (['date', 'time', 'datetime'].includes(this.type)) {
        this.vdatetimeDiv = this.$refs.root.querySelector('.vdatetime div');
        document.body.appendChild(this.vdatetimeDiv);
      }
    },

    beforeDestroy() {
      this.vdatetimeDiv && this.vdatetimeDiv.remove();
    },

    methods: {
      onFocus() {
        if (!this.data) {
          this.data = this.defaultValue;
        }
      },

      onInput() {
        this.$emit('input', this.data);
      },

      onClose() {
        // if (this.data) {
        //   this.data = null;
        //   this.$emit('input', this.data);
        // }
      },
    },
  };
</script>

<style src="vue-datetime/dist/vue-datetime.css"></style>

<style lang="scss">
  .i-input {
    position: relative;
    width: 100%;
    height: rs(58px);
  }

  .i-input .vdatetime {
    width: 100%;
    height: rs(58px);
  }

  .i-input__input {
    width: 100%;
    height: rs(58px);
    border: 0;
    border-radius: rs(58px);
    background-color: #f5f5f5;
    padding: rs(19px) rs(24px) rs(18px);
    font-size: rf(18px);
    font-weight: bold;
    color: rgba(#575167, 0.8);

    @include placeholder {
      color: rgba(#575167, 0.4);
    }

    &:focus {
      outline: none;
    }
  }

  .i-input.i-input--hidden .i-input__input {
    visibility: hidden;
  }

  .i-input__spinner {
    position: absolute;
    z-index: 1;
    top: 50%;
    right: rs(14.5px);
    width: rs(29px);
    height: rs(29px);
    transform: translate(0, -50%);
    opacity: 1;
    pointer-events: none;
    transition: opacity 0.2s;
  }

  .i-input:not(.i-input--loading) .i-input__spinner {
    opacity: 0;
  }
</style>
